<template>
  <div id="divTabview" class="card">
    <TabView :scrollable="true" @tab-click="emitTabSelected" v-model:activeIndex="activeTab">
      <TabPanel v-for="tab in scrollableTabs" :key="tab.title" :header="tab.title">
      </TabPanel>
      <!--
                <p class="m-0">{{ tab.indexOfProject }}</p>
                -->
    </TabView>
  </div>
</template>

<script setup lang="ts">
// Components
import { ref, watch, onMounted } from 'vue';
import TabView from 'primevue/tabview';
import TabPanel from 'primevue/tabpanel';
// Adds js/ts imports
// import ScrollPanel from 'primevue/scrollpanel';
import * as tabvieweditor from '@/core/tabvieweditor'
import { tabvieweditorLang, getTextFromLang } from '@/core/lang';
import { LANG } from '@/core/consts';

// emits
const emit = defineEmits(['index-of-project-to-load']);
// props
const props = defineProps(['index', 'update', 'projects', 'contentchanges', 'lang']);

//vars
const scrollableTabs = ref<{ title: string, indexOfProject: Number }[]>([]);
// const projectIndex2Load = ref(0);
const activeTab = ref(0);

const updateScrollableTabs = (lang: LANG): { title: string, indexOfProject: Number }[] => {
  // Existen proyectos cargados
  if (props.projects.length > 0) {
    return tabvieweditor.putItemIntabView(props.projects);
  }
  else {
    // Al no existir dejar el valor inicial de los tabs
    return [{
      title: getTextFromLang(
        tabvieweditorLang.scrollableTabsDefault, lang
      ),
      indexOfProject: -1
    }];
  }
}

//-- WACTHERS --
// Si se detecta un cambio en el :index, se actualiza Tab
watch(() => [props.index, props.update], ([newIndex]) => {
  scrollableTabs.value = updateScrollableTabs(props.lang);
  // Exusten proyectos cargados?
  if (props.projects.length > 0) {
    activeTab.value = newIndex;
  } else {
    activeTab.value = 0;
  }
});

/** Detectar cambio de idioma y actualizar los labels */
watch(() => props.lang, (lang) => {
  // Actualizar los items del menubar
  scrollableTabs.value = updateScrollableTabs(lang);
})

onMounted(() => {
  scrollableTabs.value = updateScrollableTabs(props.lang);
})

// methods:
// Toma el indice del node seleccionado y lo emite al parents
const emitTabSelected = (node: any) => {
  // node.index corresponde al indice del proyecto seleccionado.
  // Como el scrollableTabs es llenado con el corriende indice
  // del props projects ambos índices coinciden.
  emit('index-of-project-to-load', node.index);
}
</script>

<style scoped>
.card {
  background: var(--surface-card);
  padding: 0;
  border-radius: 10px;
  margin-bottom: 0;
}

/* https://primevue.org/theming/#scopedcss */
:deep(.p-tabview .p-tabview-panels) {
  padding: 0;
  background: gray;
}

:deep(.p-tabview .p-tabview-nav) {
  padding: 3px;
}
</style>
